
//Rubik's Flat!
//Lab Batch - 432
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstring>
#include<cstdlib>
#include<ctime>
#include<string>
#include <ezwin.h>
#include "rect.h"
#include"RectangleGraphic.h"
#include "bitmap.h"


using namespace std;

//Structure for high score...
struct highscore{
    char playername[20];
    int score;
    int extra;
};  
int hs_size=sizeof(highscore);  
 


//Global Variables...
int cube[6][3][3],temp[3],moves[10000],lastmove,movecount,time_elapsed;
bool flagwin=0;

int soln[500];

float h1=1,k1=-6,rx1=1,ry1=1;	
/* these variables are introduce so as to move the graphics easily to which ever place we want and scale it to required proportion. 
	h1 and k1 help to manipulate the position and rx1 and ry1 help for scaling the graphic along x and y directions respectively*/ 


highscore a,top[5];


FILE *fp,*hs,*hs1;

//front=0, top=1, right=2, left=3, botom=4, back=5

//Prototype definitions for all functions used...
void rotateface_clock(int);
void rotateface_anti(int);
void move(int);
void shuffle();
void reset();
void undo();
void save();
void load();
void SOLVE();
bool check();
void validate();
void high_score();

//functions for highscr.cpp
void modify_hs();
void reset_hs();
void hs_display();

//Functions for SOLVE(); in 'soln.cpp'
void reset_soln();
void improvise();

bool match_a();
bool match_b();
bool match_x();
bool match_layer();

//Display Function
void reset_display();
void movecount_display();
    

//Windows that could be needed
SimpleWindow Welcome("Rubik's Flat ! Welcome", 13.0, 13.0,
                       Position(3.0, 1.0));
SimpleWindow w("Rubik's Cube Flat!",30,20,Position(1,1)); 
SimpleWindow hscr("High Scores",20,12,Position(6.0,0.0));

//Bitmaps needed
BitMap left1(w);
BitMap left2(w);
BitMap left3(w);
BitMap right18(w);
BitMap right17(w);
BitMap right16(w);
BitMap up15(w);
BitMap up14(w);
BitMap up13(w);
BitMap down4(w);
BitMap down5(w);
BitMap down6(w);
BitMap lu10(w);
BitMap lu11(w);
BitMap lu12(w);
BitMap ru7(w);
BitMap ru8(w);
BitMap ru9(w);
BitMap resetb(w);
BitMap shuffleb(w);
BitMap saveb(w);
BitMap loadb(w);
BitMap quitb(w);
BitMap undob(w);
BitMap solnb(w);
BitMap submitb(w);

BitMap reset_hsb(hscr);

#include "mouseclick.cpp"
#include "keyboard.cpp"

//Timer Fns
int timer();

/* . . ..  . . . .. . 
		. . .. . .. . 
		 .. . . . .. 
		  . .. . . 
		  . . . ..  .
		  . . .. . . */
		  
//MainProgramme (that pretty much contains nothing)
int ApiMain() {
	//Creating Start Welcome Window
	w.Open();
  Welcome.Open();
  
  float x,y;
  float i,j;

   for(x=0.0;x<13.0;x+=0.2) {
    Welcome.RenderLine(Position(x,0.0), Position(0.0,13.0-x),
                        Black, 0.0);
    Welcome.RenderLine(Position(13.0,x), Position(13.0-x,13.0),
                        Red, 0.0);
  }
  Position Center = Welcome.GetCenter();
  Position UpperLeft = Center + Position(-1.0, -1.0);
	Position LowerRight = Center + Position(1.0,  1.0);
	Welcome.RenderText(UpperLeft, LowerRight,
	 "RUBIK'S FLAT !", Magenta);
	Position Center1 = Welcome.GetCenter();
  Position UpperLeft1 = Center1 + Position(-1.0, 2.0);
	Position LowerRight1 = Center1 + Position(1.0,  3.0);
	Welcome.RenderText(UpperLeft1, LowerRight1,
	 "Click to Continue", Cyan);

	 
  Welcome.SetMouseClickCallback(WelcomeMouseClick); 
	
  //Loading & drawing bitmaps...
	left1.Load("left.xpm");
	left1.SetPosition(Position(h1+8*rx1,k1+10*ry1));
	left1.Draw();

	left2.Load("left.xpm");
	left2.SetPosition(Position(h1+8*rx1,k1+11*ry1));
	left2.Draw();

	left3.Load("left.xpm");
	left3.SetPosition(Position(h1+8*rx1,k1+12*ry1));
	left3.Draw();

	right18.Load("right.xpm");
	right18.SetPosition(Position(h1+21*rx1,k1+10*ry1));
	right18.Draw();

	right17.Load("right.xpm");
	right17.SetPosition(Position(h1+21*rx1,k1+11*ry1));
	right17.Draw();

	right16.Load("right.xpm");
	right16.SetPosition(Position(h1+21*rx1,k1+12*ry1));
	right16.Draw();

	up13.Load("up.xpm");
	up13.SetPosition(Position(h1+14*rx1,k1+6*ry1));
	up13.Draw();

	up14.Load("up.xpm");
	up14.SetPosition(Position(h1+13*rx1,k1+6*ry1));
	up14.Draw();

	up15.Load("up.xpm");
	up15.SetPosition(Position(h1+12*rx1,k1+6*ry1));
	up15.Draw();

	down4.Load("down.xpm");
	down4.SetPosition(Position(h1+12*rx1,k1+16*ry1));
	down4.Draw();

	down5.Load("down.xpm");
	down5.SetPosition(Position(h1+13*rx1,k1+16*ry1));
	down5.Draw();

	down6.Load("down.xpm");
	down6.SetPosition(Position(h1+14*rx1,k1+16*ry1));
	down6.Draw();

	lu10.Load("lu.xpm");
	lu10.SetPosition(Position(h1+17*rx1,k1+7*ry1));
	lu10.Draw();

	lu11.Load("lu.xpm");
	lu11.SetPosition(Position(h1+16*rx1,k1+8*ry1));
	lu11.Draw();

	lu12.Load("lu.xpm");
	lu12.SetPosition(Position(h1+15*rx1,k1+9*ry1));
	lu12.Draw();

	ru7.Load("ru.xpm");
	ru7.SetPosition(Position(h1+11*rx1,k1+9*ry1));
	ru7.Draw();

	ru8.Load("ru.xpm");
	ru8.SetPosition(Position(h1+10*rx1,k1+8*ry1));
	ru8.Draw();

	ru9.Load("ru.xpm");
	ru9.SetPosition(Position(h1+9*rx1,k1+7*ry1));
	ru9.Draw();
	
	resetb.Load("reset.xpm");
	resetb.SetPosition(Position(0.5,2.5));
	resetb.Draw();

	shuffleb.Load("shuffle.xpm");
	shuffleb.SetPosition(Position(0.5,0.5));
	shuffleb.Draw();
	
	saveb.Load("save.xpm");
	saveb.SetPosition(Position(24.5,2.0));
	saveb.Draw();
	
	loadb.Load("load.xpm");
	loadb.SetPosition(Position(24.5,4.0));
	loadb.Draw();
	
	quitb.Load("quit.xpm");
	quitb.SetPosition(Position(24.5,0.5));
	quitb.Draw();

	undob.Load("undo.xpm");
	undob.SetPosition(Position(0.5,10.0));
	undob.Draw();
	
	solnb.Load("soln.xpm");
	solnb.SetPosition(Position(24.0,10.5));
	solnb.Draw();
	
	/*Position Center4 = w.GetCenter();
  Position UpperLeft4 = Center4 + Position(5.0, 1.0);
	Position LowerRight4 = Center4 + Position(7.0,  3.0);
	w.RenderText(UpperLeft4, LowerRight4,
	 movecount, Black);*/

	
/*	.Load("");
	.SetPosition(Position());
	.Draw();
*/
//we can always change the bitmaps if we don't like'em
// drawing the rubik is over :D	

//now ,taking input from the program and displaying :O

    reset();
  
   //Initiating timer
w.SetTimerCallback(timer);    
w.StartTimer(1000);

  
w.SetMouseClickCallback(mouseclick);


	return 0;
}

/* . . .. . . .. . .
	. . . . . .. . 
	 . .. . . . ..
	  . .. . . 
	  . .. ... . .*/


#include "moves.cpp"
 
#include "saveload.cpp"
#include "timer.cpp"
#include "highscr.cpp"
#include "soln.cpp" 

#include "display.cpp"
