/*----------------------------------------------------------------------------------------------------------------------------------------------------*/
//Display Function Code

void reset_display(){
	
    int i,j,k;
    Position face_tl,sq_tl;
   for(i=0;i<6;i++){
	switch(i){
		case 0:							// positions the top left corner of the face are fixed based on the 'i' value 
		{face_tl=Position(h1+12*rx1,k1+10*ry1); 
		break;}
		case 1:
		{face_tl=Position(h1+12*rx1,k1+7*ry1);
		break;}
		case 2:
		{face_tl=Position(h1+9*rx1,k1+10*ry1);
		break;}
		case 3:
		{face_tl=Position(h1+15*rx1,k1+10*ry1);
		break;}
		case 4:
		{face_tl=Position(h1+12*rx1,k1+13*ry1);
		break;}
		case 5:
		{face_tl=Position(h1+18*rx1,k1+10*ry1);
		break;}
	}
	for(j=0;j<3;j++){
		for(k=0;k<3;k++){
			sq_tl=face_tl+Position(k*rx1,j*ry1);
			switch(cube[i][j][k]){
				case 4:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Blue,true);
				break;}
				case 2:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Red,true);
				break;}
				case 1:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Green,true);
				break;}
				case 5:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Yellow,true);
				break;}
				case 0:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Cyan,true);
				break;}				
				case 3:
				{w.RenderRectangle(sq_tl,sq_tl+Position(1*rx1,1*ry1),Magenta,true);
				break;}
		
				
			}
		}
	}
}

/*----------------  3-D View(Isometric View)  ---------------------------*/
const float pi= 3.14159265,factor=10.0;
float h2=9 ,k2=11 ,rx2=1,ry2=1,rz2=1;		// center position and ratios along x,y,z
Position unit_x( cos(-pi/factor),sin(-pi/factor)  ) , unit_y( cos(-3*pi/2.0),sin(-3*pi/2.0)) , unit_z( cos(-(factor-1)*pi/factor) , sin(-(factor-1)*pi/factor)); // unit vectors along x,y,z	

	int xy=2 ,xz=0 ,yz=1;
	float ra=1,rb=1;
	Position unit1 , unit2 ;
	Position vertex=Position(h2,k2);		
	Position temp_array[4];		// temporary array used to draw the polygons
	int convert ; 


for (i=0 ; i<3 ; i++)
{
	if(i== xz)
	{unit1 = unit_x ;ra=rx2 ; unit2= unit_z; rb = rz2;}
	else if(i== xy)
	{unit1 = unit_x ;ra=rx2; unit2= unit_y; rb= ry2;}
	else if(i== yz)
	{unit1 = unit_y ;ra = ry2; unit2= unit_z; rb = rz2;}
	else
	{unit1=unit2=Position(0,0);} 

	for(j=0;j<3;j++)
	{
		for(k=0; k<3; k++)
		{
			temp_array[0] = vertex + Position(j*ra*unit1.GetXDistance()+k*rb*unit2.GetXDistance(),j*ra*unit1.GetYDistance()+k*rb*unit2.GetYDistance());
			temp_array[1] = temp_array[0] + Position(rb*unit2.GetXDistance(),rb*unit2.GetYDistance());
			temp_array[2] = temp_array[1] + Position(ra*unit1.GetXDistance(),ra*unit1.GetYDistance());
			temp_array[3] = temp_array[2] - Position(rb*unit2.GetXDistance(),rb*unit2.GetYDistance());
			
			switch(i){
	case 0:
	{convert=cube[i][j][k];
	break;}
	case 1:
	{convert=cube[i][2-j][k];
	break;}
	case 2:
	{convert=cube[i][j][2-k];
	break;}

	}
			
		switch(convert){
				case 4:
				{w.RenderPolygon(temp_array , 4 ,Blue,true);
				break;}
				case 2:
				{w.RenderPolygon(temp_array , 4 ,Red,true);
				break;}
				case 1:
				{w.RenderPolygon(temp_array , 4 ,Green,true);
				break;}
				case 5:
				{w.RenderPolygon(temp_array , 4 ,Yellow,true);
				break;}
				case 0:
				{w.RenderPolygon(temp_array , 4 ,Cyan,true);
				break;}				
				case 3:
				{w.RenderPolygon(temp_array , 4 ,Magenta,true);
				break;}
			w.RenderPolygon(temp_array , 4 ,Blue , true);
		}
		}
	}
}
	w.RenderRectangle(vertex ,vertex + Position (0.1,0.1),Yellow,true);
// // // ------------------------------------------------------------------------------------------------------------------------

h2=20 ,k2=12-((10-factor)*0.25) ,rx2=1,ry2=1,rz2=1;		// center position and ratios along x,y,z
 unit_x= Position( cos(pi/factor),sin(pi/factor)  ) , unit_y= Position( cos(3*pi/2.0),sin(3*pi/2.0)) , unit_z= Position( cos((factor-1)*pi/factor) , sin((factor-1)*pi/factor)); // unit vectors
 xy=3 ,xz=5 ,yz=4;
vertex = Position(h2,k2);
for (i=3 ; i<6 ; i++)
{
	if(i== xz)
	{unit1 = unit_x ;ra=rx2 ; unit2= unit_z; rb = rz2;}
	else if(i== xy)
	{unit1 = unit_x ;ra=rx2; unit2= unit_y; rb= ry2;}
	else if(i== yz)
	{unit1 = unit_y ;ra = ry2; unit2= unit_z; rb = rz2;}
	else
	{unit1=unit2=Position(0,0);} 

	for(j=0;j<3;j++)
	{
		for(k=0; k<3; k++)
		{
			temp_array[0] = vertex + Position(j*ra*unit1.GetXDistance()+k*rb*unit2.GetXDistance(),j*ra*unit1.GetYDistance()+k*rb*unit2.GetYDistance());
			temp_array[1] = temp_array[0] + Position(rb*unit2.GetXDistance(),rb*unit2.GetYDistance());
			temp_array[2] = temp_array[1] + Position(ra*unit1.GetXDistance(),ra*unit1.GetYDistance());
			temp_array[3] = temp_array[2] - Position(rb*unit2.GetXDistance(),rb*unit2.GetYDistance());
			
			switch(i){
	case 3:
	{convert=cube[i][2-j][2-k];
	break;}
	case 4:
	{convert=cube[i][2-j][2-k];
	break;}
	case 5:
	{convert=cube[i][2-j][k];
	break;}

	}
			
		switch(convert){
				case 4:
				{w.RenderPolygon(temp_array , 4 ,Blue,true);
				break;}
				case 2:
				{w.RenderPolygon(temp_array , 4 ,Red,true);
				break;}
				case 1:
				{w.RenderPolygon(temp_array , 4 ,Green,true);
				break;}
				case 5:
				{w.RenderPolygon(temp_array , 4 ,Yellow,true);
				break;}
				case 0:
				{w.RenderPolygon(temp_array , 4 ,Cyan,true);
				break;}				
				case 3:
				{w.RenderPolygon(temp_array , 4 ,Magenta,true);
				break;}
			w.RenderPolygon(temp_array , 4 ,Blue , true);
		}
		}
	}
}
	w.RenderRectangle(vertex ,vertex + Position (0.1,0.1),Yellow,true);

movecount_display();
}
