//SAVE-GAME and LOAD-GAME  functions  
    void save(){
        int x,i,j,k;
       
       fp=fopen("EmagDevas.bin","wb");//Saves the game(all variables defining game position & status)in a binary(.bin)file
                                          //the 'LOAD' functn later load sthem back in the same order...
       if(fp==NULL){
           w.Message("ERROR : Check disk space and permissions.");return;
       }    
       for(i=0;i<6;i++){
           for(j=0;j<3;j++){
               for(k=0;k<3;k++){
                   x=cube[i][j][k];
                   fwrite(&x,4,1,fp);
               }
           }
       }
       fwrite(&movecount,4,1,fp);
       fwrite(&lastmove,4,1,fp);
       fwrite(&time_elapsed,4,1,fp);
       fwrite(&flagwin,1,1,fp);            
       
       fclose(fp);
       w.Message("Game successfully saved.");
       
        }    
                    
//loading all variables just as they are stored
/*Storing in a .bin file makes the job simpler than with a .txt file, since in .txt we have to extract all variables as character strings,
    and then convert into corresponding data types.
    //Also .bin file makes the saved content more difficult to interpret and edit as required outside the program(as in a text-editor).
*/ 
    void load(){
        int x,i,j,k;
        bool loadchk=true;
        fp=fopen("EmagDevas.bin","rb+");
        if(fp==NULL){
           w.Message("ERROR : Load Unsuccessful. No saved game found.");return;
       }
        
        for(i=0;i<6;i++){
            for(j=0;j<3;j++){
                for(k=0;k<3;k++){
                    
                    fread(&x,4,1,fp);
                    cube[i][j][k]=x;reset_display();
                }
            }
        } 
        fread(&movecount,4,1,fp);reset_display();
        fread(&lastmove,4,1,fp);reset_display();
        fread(&time_elapsed,4,1,fp);reset_display();
        fread(&flagwin,1,1,fp);reset_display();           
        
        fclose(fp);
        
        for(i=0;i<6;i++)for(j=0;j<3;j++)for(k=0;k<3;k++)if(cube[i][j][k]>5||cube[i][j][k]<0)loadchk=false;
        if(movecount<0||movecount>9999)loadchk=false;
        if(lastmove<=0||lastmove>18)loadchk=false;
        if(time_elapsed<0)loadchk=false;
        //'loadchk' denotes whther the game has loaded correctly or not
        if(loadchk=true)w.Message("Load Successful.");
        else {w.Message("ERROR: Load Unsuccessful. Rubik's FLat! will restart... ");reset();}
        
     }
        

